import java.awt.*;
import java.awt.event.*;

import javax.swing.*; 
import javax.swing.event.*; 
import javax.swing.text.*; 

import java.text.*; 
import java.beans.*; //Property change stuff
public class TextFieldDemo extends JFrame implements ActionListener
{
  JTextField textWrite;
  JTextField contextWord;
  JTextArea textArea;
  String newline = "\n";
  // String[] instructions;
  StringBuffer word=new StringBuffer();
   String emptyString=new String("");
  JLabel instructionLabel;
  String sentence;
  FinalBE fbe;
  public TextFieldDemo() {
    super("Context Game");
    fbe = new FinalBE();
    sentence=fbe.getRandomSentence();
    //Create the text fields and set them up.
    //MyDocumentListener myDocumentListener = new MyDocumentListener();
    //ImageIcon openMindIcon=new ImageIcon("openmind_small.gif")
    textWrite = new JTextField(sentence, 50);
    textWrite.setFont(new Font("Serif", Font.BOLD, 17));
    textWrite.setForeground(Color.red);
    textWrite.setBackground(Color.black);
    textWrite.setEditable(false);
   
    JTextPane textPane=createTextPane();
    textArea = new JTextArea(20, 50);
    textArea.setForeground(Color.yellow);
    textArea.setBackground(Color.blue);
    textArea.setLineWrap(true);
    textArea.setWrapStyleWord(true);
     textArea.setEditable(false);
    JTextArea instructions=new JTextArea("Common sense knowledge previously entered into Open Mind appears above.  You must decide if this sentence is only true in a certain context and annotate the sentence as neccessary.  You may choose to change the sentence to reflect a certain time, a certain circumstance, or any other event.  If the sentence does not requrie any change, please press NONE and a new sentence will appear.",60,60);
    instructions.setLineWrap(true);
    instructions.setWrapStyleWord(true);
    instructions.setBackground(Color.yellow);
    instructions.setForeground(Color.blue);
    instructions.setEditable(false);
    JButton when=new JButton("When...");
    JButton if1 =new JButton("If...");
    JButton other=new JButton("Other...");
    JButton none=new JButton("None");
    JButton searchOthers=new JButton("What others said about this sentence");
    JButton searchConcept=new JButton("Search for context about a certain concept");
    contextWord=new JTextField(9);
    when.addActionListener(this);
    if1.addActionListener(this);
    other.addActionListener(this);
    none.addActionListener(this);
    searchOthers.addActionListener(this);
    searchConcept.addActionListener(this);
    JPanel buttons=new JPanel(new FlowLayout());
    JPanel bottomButtons=new JPanel(new FlowLayout());
    buttons.add(when);
    buttons.add(if1);
    buttons.add(other);
    buttons.add(none);
    bottomButtons.add(searchOthers);
    bottomButtons.add(searchConcept);
    bottomButtons.add(contextWord);
	
	JPanel scrollPane = new JPanel();
	scrollPane.add(textPane);
	scrollPane.add(textWrite);
	scrollPane.add(instructions);

	scrollPane.add(buttons);
	scrollPane.add(bottomButtons);
	scrollPane.setPreferredSize(new Dimension(1050, 340));
	scrollPane.setMinimumSize(new Dimension(1050, 340));
	
	Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());
	contentPane.add(scrollPane, BorderLayout.NORTH);
        contentPane.add(buttons);
	contentPane.add(bottomButtons, BorderLayout.SOUTH);
  
  }
  
  public void keyTyped(KeyEvent e) {
    // displayInfo(e, "KEY TYPED: ");
  }
  
  /** Handle the key pressed event from the text field. */
  public void keyPressed(KeyEvent e) {
                      displayInfo(e, "KEY PRESSED: ");
                  }

                  /** Handle the key released event from the text field. */
                  public void keyReleased(KeyEvent e) {
		  }
  /*
   * We have to jump through some hoops to avoid
     * trying to print non-printing characters 
     * such as Shift.  (Not only do they not print, 
     * but if you put them in a String, the characters
     * afterward won't show up in the text area.)
     */
  protected void displayInfo(KeyEvent e, String s){
    String charString, keyCodeString, modString, tmpString;
    
    char c = e.getKeyChar();
    int keyCode = e.getKeyCode();
        int modifiers = e.getModifiers();
	
        if (Character.isISOControl(c)) {
	  
	}
	if (Character.isWhitespace(c)){
	  charString= word.toString();
	  word=new StringBuffer();
	  sendWord(charString);
	}
      	if ((e.getKeyCode()==KeyEvent.VK_BACK_SPACE)&&word.length()>=1) {
	  System.out.println(word +""+ word.length());
	  word.deleteCharAt((word.length()-1));
	  System.out.println(word+""+word.length());
	  
	}
	 else {
	   
	  word.append(c);
	 }
  }
  public void sendWord(String w) {
    //send to A
    //get stringBack and display here in textArea
    textArea.append(newline + w);
  }

  private JTextPane createTextPane(){
    JTextPane textPane=new JTextPane();
    textPane.setForeground(Color.blue);
	  textPane.setBackground(Color.yellow);
	    
	  String[] instructions=
	  
	  {
	  "Teach Open Mind about different Contexts!" + newline + "",
	  "This activity presents you with some common sense knowledge that a user entered into Open Mind.  Your task is to decide if the author left out certain contextual information." + newline + "",
	  "  For example: " + newline + "",
	  "A bride wears a white wedding dress." + newline + "",
	  "This sentence is not necessarily common sense in all cultures!  For example, in another culture it might be common sense that a bride wears a Komono."+ newline + "",
	  "One could teach open mind about this by changing the sentence to say:" + newline + "",
	  "In America a bride wears a white wedding dress."
	  };

 String[] initStyles = 
                { "bold", "regular", "small", "medium/bold",
                  "regular",  "regular", 
                  "small/bold"
                };
 initStylesForTextPane(textPane);

        Document doc = textPane.getDocument();

        try {
            for (int i=0; i < instructions.length; i++) {
                doc.insertString(doc.getLength(), instructions[i],
                                 textPane.getStyle(initStyles[i]));
            }
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text.");
        }
	textPane.setEditable(false);
        return textPane;
    }
	protected void initStylesForTextPane(JTextPane textPane) {
	  //Initialize some styles.
	  Style def = StyleContext.getDefaultStyleContext().
                                        getStyle(StyleContext.DEFAULT_STYLE);
	 
	  
	  Style regular = textPane.addStyle("regular", def);
	  StyleConstants.setFontFamily(def, "SansSerif");
	  StyleConstants.setAlignment(def, StyleConstants.ALIGN_CENTER); 
	  
	  Style s = textPane.addStyle("italic", regular);
	  StyleConstants.setItalic(s, true);
	
	  s = textPane.addStyle("bold", regular);
	  StyleConstants.setBold(s, true);
	  StyleConstants.setFontSize(s, 35);
	  
	  s = textPane.addStyle("small/bold", regular);
	  StyleConstants.setFontSize(s, 20);
	  StyleConstants.setBold(s, true);
	  
	  s = textPane.addStyle("medium/bold", regular);
	  StyleConstants.setFontSize(s, 25);
	  StyleConstants.setBold(s, true);
	  
	// s = textPane.addStyle("icon", regular);
	// StyleConstants.setAlignment(s, StyleConstants.ALIGN_CENTER);
	// StyleConstants.setIcon(s, new ImageIcon("images/Pig.gif"));

        s = textPane.addStyle("button", regular);
        StyleConstants.setAlignment(s, StyleConstants.ALIGN_CENTER);
        JButton button = new JButton(new ImageIcon("openmind_small.gif"));
        button.setMargin(new Insets(0,0,0,0));
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Toolkit.getDefaultToolkit().beep();
            }
        });
        StyleConstants.setComponent(s, button);
	}


//does s/t with all the buttons etc when pressed
public void actionPerformed(ActionEvent evt)
   {
     if (evt.getActionCommand().equals("When...")) {
       when();
     } else if (evt.getActionCommand().equals("If...")){
       if1();
     } else if (evt.getActionCommand().equals("Other...")) {
       other();
     }
     else if(evt.getActionCommand().equals("None")) {
       none();
     }else if (evt.getActionCommand().equals("What others said about this sentence")){
       searchThese();
     }else if (evt.getActionCommand().equals("Search for context about a certain concept")){
       String context=contextWord.getText();
       if ((context==null)||new String("").equals(context)){
	 JOptionPane.showMessageDialog(TextFieldDemo.this, "Please enter a word into the Text Field","error",
					   JOptionPane.ERROR_MESSAGE);
	   }
       else searchOthers(context);
     }
   }

  public void searchThese()
  {
    JFrame display=new JFrame();
    display.getContentPane().setLayout(new BoxLayout(display.getContentPane(),BoxLayout.Y_AXIS));
    JLabel info=new JLabel("What others have said about:");
    JLabel info2=new JLabel(sentence);
    String otherSaidFinal="";
    for(int i=0; i<fbe.getAssociatedSentences(sentence).size(); i++)
	{
	  otherSaidFinal=new String(otherSaidFinal+newline+(String)fbe.getAssociatedSentences(sentence).get(i));
	}
   
    JTextArea sentenceArea=new JTextArea(otherSaidFinal,20,20);
    sentenceArea.setLineWrap(true);
    sentenceArea.setWrapStyleWord(true);
    sentenceArea.setBackground(Color.green);
    sentenceArea.setForeground(Color.black);
    sentenceArea.setEditable(false);
    display.getContentPane().add(info);
    display.getContentPane().add(info2);
    display.getContentPane().add(sentenceArea);
    display.pack();
    display.show();
    System.out.println("searchThese");
  }

  public void searchOthers(String context)
  {
  JFrame display=new JFrame();
  display.getContentPane().setLayout(new BoxLayout(display.getContentPane(),BoxLayout.Y_AXIS));
  JLabel info=new JLabel("What others have said about:");
  JLabel info2=new JLabel(context);
  String otherSaidFinal="";
    for(int i=0; i<fbe.getConceptSentences(context).size(); i++)
	{
	  otherSaidFinal=new String(otherSaidFinal+newline+(String)fbe.getConceptSentences(context).get(i));
	}
   
    JTextArea sentenceArea=new JTextArea(otherSaidFinal,20,20);
    sentenceArea.setLineWrap(true);
    sentenceArea.setWrapStyleWord(true);
    sentenceArea.setBackground(Color.green);
    sentenceArea.setForeground(Color.black);
    sentenceArea.setEditable(false);
    display.getContentPane().add(info);
    display.getContentPane().add(info2);
    display.getContentPane().add(sentenceArea);
    display.pack();
    display.show();
    System.out.println("searchOthers");
  }
  public void when()
  {
    JFrame frame=new JFrame("When is this true");
    Container contentPane2 = frame.getContentPane();
    contentPane2.setLayout(new GridLayout(1,1));
    contentPane2.add(new DialogDemo(frame, 0, sentence, fbe));
    frame.pack();
    frame.setVisible(true);
  }
	
    
    //test to see if null/empty
  /******PUT IN BUTTON ACTION
	 if ((text1==null)||emptyString.equals(text1)) {
	 
	 JOptionPane.showMessageDialog(TextFieldDemo.this,
	 "Please teach Open Mind",
	 "error",
	 JOptionPane.ERROR_MESSAGE);
	 }else
	 {
	 System.out.println("when");
	 }
	 }
  **************/
  
  public void if1(){
    System.out.println("if...");
    JFrame frame=new JFrame("DialogDemo2");
    Container contentPane2 = frame.getContentPane();
    contentPane2.setLayout(new GridLayout(1,1));
    contentPane2.add(new DialogDemo(frame, 1, sentence, fbe));
    frame.pack();
    frame.setVisible(true);
  }
	
 public void other()
      {
	System.out.println("other");
	System.out.println("if...");
	JFrame frame=new JFrame("DialogDemo2");
	Container contentPane2 = frame.getContentPane();
	contentPane2.setLayout(new GridLayout(1,1));
	contentPane2.add(new DialogDemo(frame, 2, sentence, fbe));
	frame.pack();
        frame.setVisible(true);
      }

public void none()
{
  //*******BRINGS UP A NEW SENTENCE
  sentence=fbe.getRandomSentence();
  textWrite.setText(sentence);
  textWrite.repaint();
}
  
    public static void main(String[] args) {
        final TextFieldDemo demo = new TextFieldDemo();

        demo.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }

    	  });
        demo.pack();
        demo.setVisible(true);
    }
}
